#!/usr/bin/env python3
# -*- coding:utf-8 -*-


import PyTango
import os
import numpy as np
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import time
import sys
import csv

print(sys.version)

devprodic = {}
devprodic["costanti"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/misc/ranges")
devprodic["trls8"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/motor/trls_sl.08")
devprodic["triggerEVR"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/ec-sl-slpsr-01/evr/ff100000")
devprodic["triggerEVR2"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/ec-sl-slpsr-01/evr/ff200000")
devprodic["triggerS2"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/delay/dgq_slpsr.01")
devprodic["sdg2"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/delay/sdg_slr.02")
devprodic["feedbackelite"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/feedback/rtltf_osc.01")
devprodic["totemdelay"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/slu/motor/trls_slu.05")
#devprodic["scope6"] = PyTango.DeviceProxy("srv-tango-srf-01:20000/sl/diagnostics/scope_sl.01")
# imposto subito velocita` 100 per salvare tempo procedura
devprodic["trls8"].write_attribute("Speed", 300)

####ns12 = 12.675074466
####ns6 = 6.337537233

class MainWindow(QDialog):
    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        #meglio scrivere per chi faccio i conti
        self.funzionamento = QLineEdit("No errors")
        self.funzionamento.setReadOnly(1)
        self.funzionamento.setStyleSheet("background-color: rgb(0, 255, 0)")
        self.lanciasalvatrigger = QPushButton("Save Trigger")
        self.lanciasalvatrigger.clicked.connect(self.pannellosalvatrigger)
        self.gruppodeltat = QGroupBox("")
        self.SLUdelta_t = QLineEdit("ns")
        self.SLUcalcola = QPushButton("Calculate")
        self.SLUcalcola.clicked.connect(self.calcola)
        self.versooscilloscopio = QLabel('This program manages the delay of the SLU. Everyone knows that if on the oscilloscope the FEL signal is to the left of the SLU signal, it means that the SLU arrives after the FEL, so you must use the minus sign to remove delay at the SLU. And viceversa...')
        self.versooscilloscopio.setFont(font_grosso)
        self.versooscilloscopio.setWordWrap(True)
        lo_delta = QGridLayout()
        lo_delta.addWidget(self.versooscilloscopio, 0, 0, 1, 3)
        lo_delta.addWidget(QLabel("SLU delta t"), 1, 0, 1, 1)
        lo_delta.addWidget(self.SLUdelta_t, 1, 1, 1, 1)
        lo_delta.addWidget(self.SLUcalcola, 1, 2, 1, 1)
        self.gruppodeltat.setLayout(lo_delta)
        #
        self.gruppobottoni = QGroupBox("")
        self.apriscope = QPushButton('Open scope-laser-06')
        self.apriscope.clicked.connect(self.fapriscope)
        self.apritrigger = QPushButton('Open Seed trigger panel')
        self.apritrigger.clicked.connect(self.fapritrigger)
        self.aprihdb = QPushButton('Open HDB')
        self.aprihdb.clicked.connect(self.faprihdb)
        self.wiki = QPushButton("wiki help")
        self.wiki.clicked.connect(self.apriwiki)
        lo_bottoni = QGridLayout()
        lo_bottoni.addWidget(self.apriscope, 0, 0, 1, 3)
        lo_bottoni.addWidget(self.apritrigger, 2, 0, 1, 3)
        lo_bottoni.addWidget(self.aprihdb, 3, 0, 1, 3)
        lo_bottoni.addWidget(self.wiki, 6, 0, 1, 3)
        self.gruppobottoni.setLayout(lo_bottoni)
        #
        self.gruppocentrale = QGroupBox()
        self.scritta1 = QLabel('0 state')
        self.scritta2 = QLabel('present state')
        self.scritta3 = QLabel('calculated')
        self.scritta4 = QLabel('delta')
        self.trls8_state = QPushButton("TRLS8")
        self.trls8_state.clicked.connect(self.apritrls8)
        self.trgE2_state = QPushButton("TRG Elite2")
        self.trgE2_state.clicked.connect(self.fapritrigger)
        self.trgS2_state = QPushButton("TRG S2")
        self.trgS2_state.clicked.connect(self.fapritrigger)
        self.trls8_iniziale = QLineEdit("")
        self.trls8_iniziale.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trls8_iniziale.setReadOnly(1)
        self.trgE2_iniziale = QLineEdit("")
        self.trgE2_iniziale.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trgE2_iniziale.setReadOnly(1)
        self.trgS2_iniziale = QLineEdit("")
        self.trgS2_iniziale.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trgS2_iniziale.setReadOnly(1)
        self.trls8_read = QLineEdit("")
        self.trls8_read.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trls8_read.setReadOnly(1)
        self.trgE2_read = QLineEdit("")
        self.trgE2_read.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trgE2_read.setReadOnly(1)
        self.trgS2_read = QLineEdit("")
        self.trgS2_read.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trgS2_read.setReadOnly(1)
#        self.ddmeasure_seedpil_calcolato = QLineEdit("")
#        self.ddmeasure_slupil_calcolato = QLineEdit("")
#        self.ddmeasure_sluseed_calcolato = QLineEdit("")
        self.trls8_calcolato = QLineEdit("")
        self.trgE2_calcolato = QLineEdit("")
        self.trgS2_calcolato = QLineEdit("")
        self.trls8_delta = QLineEdit("")
        self.trgE2_delta = QLineEdit("")
        self.trgS2_delta = QLineEdit("")
        self.trls8_applica = QPushButton('Apply')
        self.trls8_applica.clicked.connect(self.disastro_solotrls8)
        self.trgE2_applica = QPushButton('Apply')
        self.trgE2_applica.clicked.connect(self.disastro_soloE2trg)
        self.trgS2_applica = QPushButton('Apply')
        self.trgS2_applica.clicked.connect(self.disastro_soloS2trg)
        self.trls8_storna = QPushButton('UNDO')
        self.trls8_storna.clicked.connect(self.doppiodisastro_solotrls8)
        self.trgE2_storna = QPushButton('UNDO')
        self.trgE2_storna.clicked.connect(self.doppiodisastro_soloE2trg)
        self.trgS2_storna = QPushButton('UNDO')
        self.trgS2_storna.clicked.connect(self.doppiodisastro_soloS2trg)
        self.ripristina = QPushButton("Restore 0state")
        self.ripristina.clicked.connect(self.ripristino)
        self.applica = QPushButton("APPLY ALL")
        self.applica.clicked.connect(self.disastro)
        self.comenondetto = QPushButton("UNDO")
        self.comenondetto.clicked.connect(self.doppiodisastro)
        lo_centrale = QGridLayout()
        lo_centrale.addWidget(self.scritta1, 0, 1)
        lo_centrale.addWidget(self.scritta2, 0, 2)
        lo_centrale.addWidget(self.scritta3, 0, 3)
        lo_centrale.addWidget(self.scritta4, 0, 4)
        lo_centrale.addWidget(self.trls8_state, 11, 0)
        lo_centrale.addWidget(self.trls8_iniziale, 11, 1)
        lo_centrale.addWidget(self.trls8_read, 11, 2)
        lo_centrale.addWidget(self.trls8_calcolato, 11, 3)
        lo_centrale.addWidget(self.trls8_delta, 11, 4)
        lo_centrale.addWidget(self.trls8_applica, 11, 5)
        lo_centrale.addWidget(self.trls8_storna, 11, 5)
        lo_centrale.addWidget(self.trgE2_state, 14, 0)
        lo_centrale.addWidget(self.trgE2_iniziale, 14, 1)
        lo_centrale.addWidget(self.trgE2_read, 14, 2)
        lo_centrale.addWidget(self.trgE2_calcolato, 14, 3)
        lo_centrale.addWidget(self.trgE2_delta, 14, 4)
        lo_centrale.addWidget(self.trgE2_applica, 14, 5)
        lo_centrale.addWidget(self.trgE2_storna, 14, 5)
        lo_centrale.addWidget(self.trgS2_state, 15, 0)
        lo_centrale.addWidget(self.trgS2_iniziale, 15, 1)
        lo_centrale.addWidget(self.trgS2_read, 15, 2)
        lo_centrale.addWidget(self.trgS2_calcolato, 15, 3)
        lo_centrale.addWidget(self.trgS2_delta, 15, 4)
        lo_centrale.addWidget(self.trgS2_applica, 15, 5)
        lo_centrale.addWidget(self.trgS2_storna, 15, 5)
        lo_centrale.addWidget(self.ripristina, 20, 1)
        lo_centrale.addWidget(self.applica, 20, 3)
        lo_centrale.addWidget(self.comenondetto, 20, 3)
        self.comenondetto.hide()
        self.gruppocentrale.setLayout(lo_centrale)
        #
#        self.grupposcope6 = QGroupBox("scope-laser-06")
#        self.enable_scope_measurament = QPushButton('Enable scope operation')
#        self.enable_scope_measurament.clicked.connect(self.abilitascope6)
#        self.ddmeasure_seedpil_text = QLabel('Seed-Pil')
#        self.ddmeasure_slupil_text = QLabel('Slu-Pil')
#        self.ddmeasure_sluseed_text = QLabel('Slu-Seed')
#        self.ddmeasure_seedpil_iniziale = QLineEdit("")
#        self.ddmeasure_seedpil_iniziale.setStyleSheet("background-color: rgb(220, 220, 220)")
#        self.ddmeasure_slupil_iniziale = QLineEdit("")
#        self.ddmeasure_slupil_iniziale.setStyleSheet("background-color: rgb(220, 220, 220)")
#        self.ddmeasure_sluseed_iniziale = QLineEdit("")
#        self.ddmeasure_sluseed_iniziale.setStyleSheet("background-color: rgb(220, 220, 220)")
#        self.ddmeasure_seedpil_read = QLineEdit("")
#        self.ddmeasure_seedpil_read.setStyleSheet("background-color: rgb(220, 220, 220)")
#        self.ddmeasure_slupil_read = QLineEdit("")
#        self.ddmeasure_slupil_read.setStyleSheet("background-color: rgb(220, 220, 220)")
#        self.ddmeasure_sluseed_read = QLineEdit("")
#        self.ddmeasure_sluseed_read.setStyleSheet("background-color: rgb(220, 220, 220)")
#        self.scope6clearswaps = QPushButton('ClearSweeps')
#        self.scope6clearswaps.clicked.connect(self.pulisci_oscilloscopio)
#        lo_scope6 = QGridLayout()
#        lo_scope6.addWidget(self.enable_scope_measurament, 1, 0)
#        lo_scope6.addWidget(self.ddmeasure_seedpil_text, 2, 0)
#        lo_scope6.addWidget(self.ddmeasure_seedpil_iniziale, 2, 1)
#        lo_scope6.addWidget(self.ddmeasure_seedpil_read, 2, 2)
#        lo_scope6.addWidget(self.ddmeasure_seedpil_calcolato, 2, 3)
#        lo_scope6.addWidget(self.ddmeasure_slupil_text, 3, 0)
#        lo_scope6.addWidget(self.ddmeasure_slupil_iniziale, 3, 1)
#        lo_scope6.addWidget(self.ddmeasure_slupil_read, 3, 2)
#        lo_scope6.addWidget(self.ddmeasure_slupil_calcolato, 3, 3)
#        lo_scope6.addWidget(self.ddmeasure_sluseed_text, 4, 0)
#        lo_scope6.addWidget(self.ddmeasure_sluseed_iniziale, 4, 1)
#        lo_scope6.addWidget(self.ddmeasure_sluseed_read, 4, 2)
#        lo_scope6.addWidget(self.ddmeasure_sluseed_calcolato, 4, 3)
#        lo_scope6.addWidget(self.scope6clearswaps, 2, 4, 3, 1)
#        self.grupposcope6.setLayout(lo_scope6)
        #
        self.gruppotrls8 = QGroupBox("TRLS8 (positive movement ADD delay, negative movement REMOVE delay. Range -6670ps, 6670ps)")
        self.trls8_tasto = QPushButton('panel')
        self.trls8_tasto.clicked.connect(self.apritrls8)
        self.trls8_readd = QLineEdit('')
        self.trls8_readd.setReadOnly(1)
        self.trls8_readd.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trls8_goto = QPushButton('GoTo:')
        self.trls8_goto.clicked.connect(self.delay8goto)
        self.trls8_set = QLineEdit('')
        self.trls8_b = QPushButton('<')
        self.trls8_b.clicked.connect(self.delay8meno)
        self.trls8_rel = QLineEdit('')
        self.trls8_f = QPushButton('>')
        self.trls8_f.clicked.connect(self.delay8piu)
        lo_trls8 = QGridLayout()
        lo_trls8.addWidget(self.trls8_tasto, 0, 0)
        lo_trls8.addWidget(self.trls8_readd, 0, 1)
        lo_trls8.addWidget(self.trls8_goto, 0, 2)
        lo_trls8.addWidget(self.trls8_set, 0, 3)
        lo_trls8.addWidget(self.trls8_b, 0, 4)
        lo_trls8.addWidget(self.trls8_rel, 0, 5)
        lo_trls8.addWidget(self.trls8_f, 0, 6)
        self.gruppotrls8.setLayout(lo_trls8)
        #
        self.gruppotrls5 = QGroupBox("Totem delay line (positive movement ADD delay, negative movement REMOVE delay. Range -682ps, 717ps)")
        self.trls5_tasto = QPushButton('panel')
        self.trls5_tasto.clicked.connect(self.delaytotemapri)
        self.trls5_read = QLineEdit('')
        self.trls5_read.setReadOnly(1)
        self.trls5_read.setStyleSheet("background-color: rgb(220, 220, 220)")
        self.trls5_goto = QPushButton('GoTo:')
        self.trls5_goto.clicked.connect(self.delaytotemgoto)
        self.trls5_set = QLineEdit('')
        self.trls5_b = QPushButton('<')
        self.trls5_b.clicked.connect(self.delaytotemmeno)
        self.trls5_rel = QLineEdit('')
        self.trls5_f = QPushButton('>')
        self.trls5_f.clicked.connect(self.delaytotempiu)
        lo_trls5 = QGridLayout()
        lo_trls5.addWidget(self.trls5_tasto, 0, 0)
        lo_trls5.addWidget(self.trls5_read, 0, 1)
        lo_trls5.addWidget(self.trls5_goto, 0, 2)
        lo_trls5.addWidget(self.trls5_set, 0, 3)
        lo_trls5.addWidget(self.trls5_b, 0, 4)
        lo_trls5.addWidget(self.trls5_rel, 0, 5)
        lo_trls5.addWidget(self.trls5_f, 0, 6)
        self.gruppotrls5.setLayout(lo_trls5)
        #
        self.logbox = QListWidget()
        self.logbox.setMaximumHeight(80)
        lo_pannello = QGridLayout()
        lo_pannello.addWidget(self.funzionamento, 0, 0)
        lo_pannello.addWidget(self.lanciasalvatrigger, 0, 3)
        lo_pannello.addWidget(self.gruppodeltat, 1, 0, 1, 3)
        lo_pannello.addWidget(self.gruppobottoni, 1, 3)
        lo_pannello.addWidget(self.gruppocentrale, 2, 0, 1, 4)
        lo_pannello.addWidget(self.gruppotrls8, 3, 0, 1, 4)
        lo_pannello.addWidget(self.gruppotrls5, 4, 0, 1, 4)
        lo_pannello.addWidget(self.logbox, 5, 0, 1, 4)
        self.setLayout(lo_pannello)
        self.show()
        self.setWindowTitle("SLU LAZY DELAY V5")
        self.trls8_storna.hide()
        self.trgE2_storna.hide()
        self.trgS2_storna.hide()
        #inizializzazione - lettura parametri
        self.contaloop = 0
        self.abilitazioscope6 = 0
        try:
            self.zero_trls8 = devprodic["trls8"].Position
            self.trls8_iniziale.setText(str(round(self.zero_trls8, 3)))
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["trls8"]) + ' Position. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
        try:
            self.zero_trgS2 = devprodic["triggerS2"].command_inout('GetDelay', 2)*1000000000
            self.trgS2_iniziale.setText(str(round(self.zero_trgS2, 1)))
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerS2"]) + ' S2Delay. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
        try:
            self.zero_trgE2 = devprodic["triggerEVR"].Chan2Delay
            self.trgE2_iniziale.setText(str(round(self.zero_trgE2, 1)))
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerEVR"]) + ' Chan2Delay. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
#        try:
#            tmp = self.lettura_oscilloscopio("P1")
#            if tmp[1] > 12 or tmp[1] == 0:
#                self.ddmeasure_seedpil_iniziale.setStyleSheet("background-color: rgb(255, 0, 0)")
#                self.ddmeasure_seedpil_iniziale.setText(str(tmp[0]) + ' ns, sigma ' + str(tmp[1]) + ' ns')
#            elif 0.2 < tmp[1] < 12:
#                self.ddmeasure_seedpil_iniziale.setStyleSheet("background-color: rgb(255, 255, 0)")
#                self.ddmeasure_seedpil_iniziale.setText(str(tmp[0]) + ' ns, sigma ' + str(tmp[1]) + ' ns')
#            elif tmp[1] < 0.2:
#                self.ddmeasure_seedpil_iniziale.setStyleSheet("background-color: rgb(0, 255, 0)")
#                self.ddmeasure_seedpil_iniziale.setText(str(tmp[0]) + ' ns')
#            tmp = self.lettura_oscilloscopio("P2")
#            if tmp[1] > 12 or tmp[1] == 0:
#                self.ddmeasure_slupil_iniziale.setStyleSheet("background-color: rgb(255, 0, 0)")
#                self.ddmeasure_slupil_iniziale.setText(str(tmp[0]) + ' ns, sigma ' + str(tmp[1]) + ' ns')
#            elif 0.2 < tmp[1] < 12:
#                self.ddmeasure_slupil_iniziale.setStyleSheet("background-color: rgb(255, 255, 0)")
#                self.ddmeasure_slupil_iniziale.setText(str(tmp[0]) + ' ns, sigma ' + str(tmp[1]) + ' ns')
#            elif tmp[1] < 0.2:
#                self.ddmeasure_slupil_iniziale.setStyleSheet("background-color: rgb(0, 255, 0)")
#                self.ddmeasure_slupil_iniziale.setText(str(tmp[0]) + ' ns')
#            tmp = self.lettura_oscilloscopio("P3")
#            if tmp[1] > 12 or tmp[1] == 0:
#                self.ddmeasure_sluseed_iniziale.setStyleSheet("background-color: rgb(255, 0, 0)")
#                self.ddmeasure_sluseed_iniziale.setText(str(tmp[0]) + ' ns, sigma ' + str(tmp[1]) + ' ns')
#            elif 0.2 < tmp[1] < 12:
#                self.ddmeasure_sluseed_iniziale.setStyleSheet("background-color: rgb(255, 255, 0)")
#                self.ddmeasure_sluseed_iniziale.setText(str(tmp[0]) + ' ns, sigma ' + str(tmp[1]) + ' ns')
#            elif tmp[1] < 0.2:
#                self.ddmeasure_sluseed_iniziale.setStyleSheet("background-color: rgb(0, 255, 0)")
#                self.ddmeasure_sluseed_iniziale.setText(str(tmp[0]) + ' ns')
#        except:
#            self.ddmeasure_seedpil_read.setStyleSheet("background-color: rgb(200, 200, 200)")
#            self.ddmeasure_seedpil_read.setText('')
#            self.ddmeasure_slupil_read.setStyleSheet("background-color: rgb(200, 200, 200)")
#            self.ddmeasure_slupil_read.setText('')
#            self.ddmeasure_sluseed_read.setStyleSheet("background-color: rgb(200, 200, 200)")
#            self.ddmeasure_sluseed_read.setText('')
#            self.ddmeasure_seedpil_iniziale.setStyleSheet("background-color: rgb(200, 200, 200)")
#            self.ddmeasure_seedpil_iniziale.setText('')
#            self.ddmeasure_slupil_iniziale.setStyleSheet("background-color: rgb(200, 200, 200)")
#            self.ddmeasure_slupil_iniziale.setText('')
#            self.ddmeasure_sluseed_iniziale.setStyleSheet("background-color: rgb(200, 200, 200)")
#            self.ddmeasure_sluseed_iniziale.setText('')
#            self.scope6clearswaps.setStyleSheet("background-color: rgb(200, 200, 200)")
        #timer
        self.timer = QBasicTimer()
        self.timer.start(1000, self)

    def timerEvent(self, event):
        tinizio = time.time()
        try:
            tmp = devprodic["trls8"].read_attributes(['State', 'Position'])
            self.read_values_trls8_state = str(tmp[0].value)
            self.read_values_trls8_position = tmp[1].value
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["trls8"]) + ' State and Position. fix the problem and procede'
            self.logbox.insertItem(0, voce)
        try:
            self.read_values_trg_S2_state = str(devprodic["triggerS2"].State())
            self.read_values_trg_S2_delay = devprodic["triggerS2"].command_inout('GetDelay', 2)*1000000000
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerS2"]) + ' S2Delay. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
        try:
            tmp = devprodic["triggerEVR"].read_attributes(['State', 'Chan1Delay', 'Chan2Delay'])
            self.read_values_trg_state = str(tmp[0].value)
#            self.read_values_trg_E1_delay = tmp[1].value
            self.read_values_trg_E2_delay = tmp[2].value
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerEVR"]) + ' State, Chan1Delay, Chan2Delay. fix the problem and procede'
            self.logbox.insertItem(0, voce)
        self.trls8pos = self.read_values_trls8_position/1000
        try:
            tmp = devprodic["totemdelay"].read_attributes(['State', 'Position'])
            if str(tmp[0].value) == 'ON' or str(tmp[0].value) == 'RUNNING':
                self.trls5_tasto.setStyleSheet("background-color: rgb(0, 255, 0)")
            elif str(tmp[0].value) == 'MOVING':
                self.trls5_tasto.setStyleSheet("background-color: rgb(0, 0, 255)")
            elif str(tmp[0].value) == 'FAULT' or str(tmp[0].value) == 'ALARM':
                self.trls5_tasto.setStyleSheet("background-color: rgb(255, 0, 0)")
            else:
                self.trls5_tasto.setStyleSheet("background-color: rgb(150, 150, 150)")
            self.trls5_read.setText(str(round(tmp[1].value, 3)) + ' ps')
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            self.trls5_read.setText('#####')
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["totemdelay"]) + ' State and Position. fix the problem and procede'
            self.logbox.insertItem(0, voce)
        ###aggiornamento pannello###
        if self.read_values_trls8_state == "ON" or self.read_values_trls8_state == "RUNNING":
            self.trls8_state.setStyleSheet("background-color: rgb(0, 255, 0)")
            self.trls8_tasto.setStyleSheet("background-color: rgb(0, 255, 0)")
        elif self.read_values_trls8_state == "MOVING":
            self.trls8_state.setStyleSheet("background-color: rgb(0, 0, 255)")
            self.trls8_tasto.setStyleSheet("background-color: rgb(0, 0, 255)")
        elif self.read_values_trls8_state == "FAULT" or self.read_values_trls8_state == "ALARM":
            self.trls8_state.setStyleSheet("background-color: rgb(255, 0, 0)")
            self.trls8_tasto.setStyleSheet("background-color: rgb(255, 0, 0)")
        else:
            self.trls8_state.setStyleSheet("background-color: rgb(150, 150, 150)")
            self.trls8_tasto.setStyleSheet("background-color: rgb(150, 150, 150)")
        if self.read_values_trg_S2_state == "ON" or self.read_values_trg_S2_state == "RUNNING":
            self.trgS2_state.setStyleSheet("background-color: rgb(0, 255, 0)")
            self.trgS2_state.setStyleSheet("background-color: rgb(0, 255, 0)")
        elif self.read_values_trg_S2_state == "MOVING":
            self.trgS2_state.setStyleSheet("background-color: rgb(0, 0, 255)")
            self.trgS2_state.setStyleSheet("background-color: rgb(0, 0, 255)")
        elif self.read_values_trg_S2_state == "FAULT" or self.read_values_trg_S2_state == "ALARM":
            self.trgS2_state.setStyleSheet("background-color: rgb(255, 0, 0)")
            self.trgS2_state.setStyleSheet("background-color: rgb(255, 0, 0)")
        else:
            self.trgS2_state.setStyleSheet("background-color: rgb(150, 150, 150)")
            self.trgS2_state.setStyleSheet("background-color: rgb(150, 150, 150)")
        if self.read_values_trg_state == "ON" or self.read_values_trg_state == "RUNNING":
            self.trgE2_state.setStyleSheet("background-color: rgb(0, 255, 0)")
        elif self.read_values_trg_state == "MOVING":
            self.trgE2_state.setStyleSheet("background-color: rgb(0, 0, 255)")
        elif self.read_values_trg_state == "FAULT" or self.read_values_trg_state == "ALARM":
            self.trgE2_state.setStyleSheet("background-color: rgb(255, 0, 0)")
        else:
            self.trgE2_state.setStyleSheet("background-color: rgb(150, 150, 150)")
        self.trls8_read.setText(str(round(self.read_values_trls8_position, 3)) + " ps")
        self.trls8_readd.setText(str(round(self.read_values_trls8_position, 3)) + " ps")
        self.trgE2_read.setText(str(round(self.read_values_trg_E2_delay, 3)) + " ns")
        self.trgS2_read.setText(str(round(self.read_values_trg_S2_delay, 3)) + " ns")
        if self.trls8_calcolato.text() != '':
            self.trls8_delta.setText(str(round(float(self.trls8_read.text().replace(' ps', '')) - float(self.trls8_calcolato.text().replace(' ps', '')), 3)) + ' ps')
        if self.trgE2_calcolato.text() != '':
            self.trgE2_delta.setText(str(round(float(self.trgE2_read.text().replace(' ns', '')) - float(self.trgE2_calcolato.text().replace(' ns', '')), 3)) + ' ns')
        if self.trgS2_calcolato.text() != '':
            self.trgS2_delta.setText(str(round(float(self.trgS2_read.text().replace(' ns', '')) - float(self.trgS2_calcolato.text().replace(' ns', '')), 3)) + ' ns')


    def closeEvent(self, event):
        devprodic["trls8"].write_attribute("Speed", 1)
        self.timer.stop()
        ret = QMessageBox.warning(None, 'Trigger reference file', 'Please, do not forget to save the new trigger reference file!')

    def calcola(self): # muovi SLU
        ###verifica validita input###
        test = str(self.SLUdelta_t.text().replace(',','.').replace('.','').replace(' ','').replace('ns','').replace('-',''))
        if test.isdigit(): #verifico se input corretto
            delta_t = float(self.SLUdelta_t.text().replace(',','.').replace(' ','').replace('ns',''))
            print('richiesta ' + str(delta_t))
        else:
            print('SLU delay not a number')
            return 
        ###calcolo###
        resto = (delta_t/12.675074466 - int(delta_t/12.675074466))*12.675074466 #ns, avanzo da dare in pasto ai traslatori
        trg_e2_tmp = self.read_values_trg_E2_delay + int(delta_t/12.675074466)*12.675074466 #valore tmp, perche potrebbe cambiare di 1 cilclo per via dei traslatori
         # valuto corsa disponibile sulla slitta, se delta_t oltre i limiti agisco ancora sul trigger
        if self.trls8pos + resto >= -6.6 and self.trls8pos + resto <= 6.6:
            self.trls8calc = self.trls8pos + resto
            print("caso 1: trls8 entro i limiti")
            self.trg_elite2calc = trg_e2_tmp
        elif self.trls8pos + resto < -6.6:
            print("caso 2: trls8 sotto i limiti")
            self.trls8calc = self.trls8pos + resto + 12.675074466
            self.trg_elite2calc = trg_e2_tmp - 12.675074466
        elif self.trls8pos + resto > 6.6:
            print("caso 3: trls8 sopra i limiti")
            self.trls8calc = self.trls8pos + resto - 12.675074466
            self.trg_elite2calc = trg_e2_tmp + 12.675074466
        # valuto spostamento SDG
        self.trg_S2calc = self.zero_trgS2 + int(self.zero_trls8 - self.trls8calc)
        print(self.zero_trls8)
        print(self.trls8calc)
        print(self.trg_S2calc)
        # popolo il pannello di numeri
        self.trls8_calcolato.setText(str(round(self.trls8calc*1000, 3)) + ' ps')
        self.trgE2_calcolato.setText(str(round(self.trg_elite2calc, 3)) + ' ns')
        self.trgS2_calcolato.setText(str(round(self.trg_S2calc, 3)) + ' ns')
        if self.trls8calc*1000 < -6600 or self.trls8calc*1000 > 6600:
            self.trls8_calcolato.setStyleSheet("background-color: rgb(255, 0, 0)")
        else: 
            self.trls8_calcolato.setStyleSheet("background-color: rgb(255, 255, 255)")
        self.applica.show()
        self.trls8_applica.show()
        self.trgE2_applica.show()
        self.trgS2_applica.show()
        self.comenondetto.hide()
        self.trls8_storna.hide()
        self.trgE2_storna.hide()
        self.trgS2_storna.hide()

    def pannellosalvatrigger(self):
        os.chdir('/home/lfo/data/salvatutto/SEED_trigger/')
        sonoin = os.path.abspath('')
        indice = 0
        for file in os.listdir(sonoin):
            if file.endswith(".csv"):
                indice = indice +1
        nomefile = '/home/lfo/data/salvatutto/SEED_trigger/' + str(indice+1) + '.csv'
        listaEVR1 = [0, 1, 2, 3, 8, 9, 10, 11, 12, 13]
        listaDGQ1 = [1, 2, 3, 4, 5, 6, 7, 8]
        listaSDG1 = [1, 2]
        listaEVR2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]
        listaDGQ2 = [1, 2, 3, 4, 5, 6, 7, 8]
        listaSDG2 = [1, 2]
        datidasalvare = []
        nomidasalvare = []
        #leggo dati
        tmp = devprodic["triggerEVR"].ChanDelay
        for corridore in range(len(tmp)):
            if corridore in listaEVR1:
                nomidasalvare.append("EVR1 " + str(corridore))
                datidasalvare.append(tmp[corridore])
        for corridore in range(len(listaDGQ1)):
            tmp = devprodic["triggerS2"].command_inout('GetDelay', listaDGQ1[corridore])
            nomidasalvare.append("DGQ1 " + str(corridore+1))
            datidasalvare.append(str(tmp))
        tmp = devprodic["sdg1"].Channel1Delay
        nomidasalvare.append("SDG1 1")
        datidasalvare.append(str(tmp))
        tmp = devprodic["sdg1"].Channel2Delay
        nomidasalvare.append("SDG1 2")
        datidasalvare.append(str(tmp))
        for corridore in range(len(listaDGQ2)):
            tmp = devprodic["triggerS1"].command_inout('GetDelay', listaDGQ2[corridore])
            nomidasalvare.append("DGQ2 " + str(corridore+1))
            datidasalvare.append(str(tmp))
        tmp = devprodic["sdg2"].Channel1Delay
        nomidasalvare.append("SDG2 1")
        datidasalvare.append(str(tmp))
        tmp = devprodic["sdg2"].Channel2Delay
        nomidasalvare.append("SDG2 2")
        datidasalvare.append(str(tmp))
        tmp = devprodic["triggerEVR2"].ChanDelay
        for corridore in range(len(tmp)):
            if corridore in listaEVR2:
                nomidasalvare.append("EVR2 " + str(corridore))
                datidasalvare.append(tmp[corridore])
        #verifico che tutti i numeri siano numeri
        collettorediproblemi = 0
        for corridore in range(len(datidasalvare)):
            try:
                a = float(datidasalvare[corridore])
                if a == -1:
                    collettorediproblemi = 1
            except:
                print('!!!!!!!!!!!!!!!')
                print(nomidasalvare[corridore] + ' ' + datidasalvare[corridore])
                collettorediproblemi = 1
        if collettorediproblemi == 0: # se non ci sono problemi creo nuovo file e lo riempio
            print('tutto ok')
            #salvo nuovo file
            with open(nomefile, 'w', newline='') as csvfile:
                spamwriter = csv.writer(csvfile)
                for ind in range(len(datidasalvare)):
                    riga = [nomidasalvare[ind], str(datidasalvare[ind])]
                    spamwriter.writerow(riga)
            csvfile.close()
            QMessageBox.warning(None, 'Save SEED trigger', 'file saved: ' + nomefile)
        else:
            QMessageBox.warning(None, 'Save SEED trigger', 'problems reading 1 or more delays. please try again')
        # sistemo eventuali allarmi
        # EVR1
        for corridore in range(len(listaEVR1)):
            print('EVR1 ch' + str(corridore))
            applicalo =0
            lettura = eval('devprodic["triggerEVR"].Chan' + str(listaEVR1[corridore]) + 'Delay')
            altro = eval('devprodic["triggerEVR"].get_attribute_config_ex("Chan' + str(listaEVR1[corridore]) + 'Delay")')
            if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
                altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
                applicalo = 1
            if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
                altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
                applicalo = 1
            if altro[0].alarms.min_warning != 'Not specified':
                altro[0].alarms.min_warning = 'Not specified'
                applicalo = 1
            if altro[0].alarms.max_warning != 'Not specified':
                altro[0].alarms.max_warning = 'Not specified'
                applicalo = 1
            if applicalo == 1:
                devprodic["triggerEVR"].set_attribute_config(altro)
                print('alarm updated')
            time.sleep(0.1)
        # EVR2
        for corridore in range(len(listaEVR2)):
            print('EVR2 ch' + str(corridore))
            applicalo =0
            lettura = eval('devprodic["triggerEVR2"].Chan' + str(listaEVR2[corridore]) + 'Delay')
            altro = eval('devprodic["triggerEVR2"].get_attribute_config_ex("Chan' + str(listaEVR2[corridore]) + 'Delay")')
            if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
                altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
                applicalo = 1
            if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
                altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
                applicalo = 1
            if altro[0].alarms.min_warning != 'Not specified':
                altro[0].alarms.min_warning = 'Not specified'
                applicalo = 1
            if altro[0].alarms.max_warning != 'Not specified':
                altro[0].alarms.max_warning = 'Not specified'
                applicalo = 1
            if applicalo == 1:
                devprodic["triggerEVR2"].set_attribute_config(altro)
                print('alarm updated')
            time.sleep(0.1)
        # DGQ1
        for corridore in range(len(listaDGQ1)):
            print('DGQ1 ch' + str(corridore))
            applicalo =0
            lettura = eval('devprodic["triggerS2"].Chan' + str(listaDGQ1[corridore]) + 'Delay')
            altro = eval('devprodic["triggerS2"].get_attribute_config_ex("Chan' + str(listaDGQ1[corridore]) + 'Delay")')
            if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
                altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
                applicalo = 1
            if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
                altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
                applicalo = 1
            if altro[0].alarms.min_warning != 'Not specified':
                altro[0].alarms.min_warning = 'Not specified'
                applicalo = 1
            if altro[0].alarms.max_warning != 'Not specified':
                altro[0].alarms.max_warning = 'Not specified'
                applicalo = 1
            if applicalo == 1:
                devprodic["triggerS2"].set_attribute_config(altro)
                print('alarm updated')
            time.sleep(0.2)
        # DGQ2
        for corridore in range(len(listaDGQ2)):
            print('DGQ2 ch' + str(corridore))
            applicalo =0
            lettura = eval('devprodic["triggerS1"].Chan' + str(listaDGQ2[corridore]) + 'Delay')
            altro = eval('devprodic["triggerS1"].get_attribute_config_ex("Chan' + str(listaDGQ2[corridore]) + 'Delay")')
            if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
                altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
                applicalo = 1
            if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
                altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
                applicalo = 1
            if altro[0].alarms.min_warning != 'Not specified':
                altro[0].alarms.min_warning = 'Not specified'
                applicalo = 1
            if altro[0].alarms.max_warning != 'Not specified':
                altro[0].alarms.max_warning = 'Not specified'
                applicalo = 1
            if applicalo == 1:
                devprodic["triggerS1"].set_attribute_config(altro)
                print('alarm updated')
            time.sleep(0.2)
        # SDG1
        applicalo =0
        print('SDG1')
        lettura = devprodic["sdg1"].Channel1Delay
        altro = devprodic["sdg1"].get_attribute_config_ex('Channel1Delay')
        if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
            altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
            applicalo = 1
        if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
            altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
            applicalo = 1
        if altro[0].alarms.min_warning != 'Not specified':
            altro[0].alarms.min_warning = 'Not specified'
            applicalo = 1
        if altro[0].alarms.max_warning != 'Not specified':
            altro[0].alarms.max_warning = 'Not specified'
            applicalo = 1
        if applicalo == 1:
            devprodic["sdg1"].set_attribute_config(altro)
            print('alarm updated')
        time.sleep(0.2)
        applicalo =0
        lettura = devprodic["sdg1"].Channel2Delay
        altro = devprodic["sdg1"].get_attribute_config_ex('Channel2Delay')
        if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
            altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
            applicalo = 1
        if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
            altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
            applicalo = 1
        if altro[0].alarms.min_warning != 'Not specified':
            altro[0].alarms.min_warning = 'Not specified'
            applicalo = 1
        if altro[0].alarms.max_warning != 'Not specified':
            altro[0].alarms.max_warning = 'Not specified'
            applicalo = 1
        if applicalo == 1:
            devprodic["sdg1"].set_attribute_config(altro)
            print('alarm updated')
        # SDG1
        applicalo =0
        print('SDG2')
        lettura = devprodic["sdg2"].Channel1Delay
        altro = devprodic["sdg2"].get_attribute_config_ex('Channel1Delay')
        if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
            altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
            applicalo = 1
        if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
            altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
            applicalo = 1
        if altro[0].alarms.min_warning != 'Not specified':
            altro[0].alarms.min_warning = 'Not specified'
            applicalo = 1
        if altro[0].alarms.max_warning != 'Not specified':
            altro[0].alarms.max_warning = 'Not specified'
            applicalo = 1
        if applicalo == 1:
            devprodic["sdg2"].set_attribute_config(altro)
        time.sleep(0.2)
        applicalo =0
        lettura = devprodic["sdg2"].Channel2Delay
        altro = devprodic["sdg2"].get_attribute_config_ex('Channel2Delay')
        if altro[0].alarms.min_alarm != str(float(lettura) - 1.0):
            altro[0].alarms.min_alarm = str(float(lettura) - 1.0)
            applicalo = 1
        if altro[0].alarms.max_alarm != str(float(lettura) + 1.0):
            altro[0].alarms.max_alarm = str(float(lettura) + 1.0)
            applicalo = 1
        if altro[0].alarms.min_warning != 'Not specified':
            altro[0].alarms.min_warning = 'Not specified'
            applicalo = 1
        if altro[0].alarms.max_warning != 'Not specified':
            altro[0].alarms.max_warning = 'Not specified'
            applicalo = 1
        if applicalo == 1:
            devprodic["sdg2"].set_attribute_config(altro)
        #verifica
        indice1 = 0
        for file in os.listdir(sonoin):
            if file.endswith(".csv"):
                indice1 = indice1 +1
        print(indice)
        print(indice1)
        if indice1 > indice:
            self.lanciasalvatrigger.setStyleSheet("background-color: rgb(0, 255, 0)")
        else:
            self.lanciasalvatrigger.setStyleSheet("background-color: rgb(255, 0, 0)")

    def faprihdb(self):
        os.system('firefox http://fcsproxy.elettra.trieste.it/docs/egiga2m/egiga2m.html?conf=fermi_hdbpp &')

    def apriwiki(self):
        os.system('firefox http://acswww.elettra.trieste.it/Fermi/Procedures/Lasers/SLUtimimingnumbers &')

    def apritrls8(self):
        os.system('/runtime/bin/xps-gui sl/motor/trls_sl.08 -title SLU_delay_line_trls_sl.08 &')

    def fapriscope(self):
        os.system('/usr/bin/vncviewer scope-laser-06 &')

    def fapritrigger(self):
        os.system('/runtime/bin/sl-trigger-gui &')

    def delaytotemapri(self):
        os.system('/runtime/bin/motion_controller slu/motor/trls_slu.05 -title SLU_TOTEM_DELAY_LINE &')

    def delaytotemgoto(self):
        gol = float(self.trls5_set.text())
        devprodic["totemdelay"].write_attribute('Position', gol)

    def delaytotempiu(self):
        gol = devprodic["totemdelay"].Position + float(self.trls5_rel.text())
        devprodic["totemdelay"].write_attribute('Position', gol)

    def delaytotemmeno(self):
        gol = devprodic["totemdelay"].Position - float(self.trls5_rel.text())
        devprodic["totemdelay"].write_attribute('Position', gol)

    def delay8goto(self):
        gol = float(self.trls8_set.text())
        devprodic["trls8"].write_attribute('Position', gol)

    def delay8piu(self):
        gol = devprodic["trls8"].Position + float(self.trls8_rel.text())
        devprodic["trls8"].write_attribute('Position', gol)

    def delay8meno(self):
        gol = devprodic["trls8"].Position - float(self.trls8_rel.text())
        devprodic["trls8"].write_attribute('Position', gol)

    def disastro_solotrls8(self):
        try:
            self.trls8_old = devprodic["trls8"].Position
            procedi = True
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["trls8"]) + ' Position.'
            self.logbox.insertItem(0, voce)
            procedi = False
        if procedi:
            self.comandifalliti = 0
            try:
                devprodic["trls8"].write_attribute("Position", float(self.trls8calc*1000))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["trls8"]) + ' while write_attribute("Position", ' + str(self.trls8calc*1000) + ')'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
        if self.comandifalliti < 1:
            self.trls8_applica.hide()
            self.trls8_storna.show()

    def doppiodisastro_solotrls8(self):
        devprodic["trls8"].write_attribute("Position", self.trls8_old)
        self.trls8_applica.show()
        self.trls8_storna.hide()

    def disastro_soloE2trg(self):
        try:
            self.trgE2_old = devprodic["triggerEVR"].Chan2Delay
            procedi = True
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerEVR"]) + ' Chan2Delay.'
            self.logbox.insertItem(0, voce)
            procedi = False
        if procedi:
            self.comandifalliti = 0
            try:
                devprodic["triggerEVR"].write_attribute("Chan2Delay", float(self.trg_elite2calc))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while write_attribute("Chan2Delay", ' + str(self.trg_elite2calc) + ')'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
            time.sleep(0.2)
            try:
                tmp = devprodic["triggerEVR"].get_attribute_config_ex("Chan2Delay")
                tmp[0].alarms.min_alarm = str(self.trg_elite2calc - 1)
                tmp[0].alarms.max_alarm = str(self.trg_elite2calc + 1)
                devprodic["triggerEVR"].set_attribute_config(tmp)
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while the script set alarm threshold [' + str(self.trg_elite2calc - 1) + ', ' + str(self.trg_elite2calc +1) + '] for attribute Chan2Delay'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
        if self.comandifalliti < 1:
            self.trgE2_applica.hide()
            self.trgE2_storna.show()

    def doppiodisastro_soloE2trg(self):
        devprodic["triggerEVR"].write_attribute('Chan2Delay', self.trgE2_old)
        tmp = devprodic["triggerEVR"].get_attribute_config_ex('Chan2Delay')
        tmp[0].alarms.min_alarm = str(self.trgE2_old - 1)
        tmp[0].alarms.max_alarm = str(self.trgE2_old + 1)
        devprodic["triggerEVR"].set_attribute_config(tmp)
        self.trgE2_applica.show()
        self.trgE2_storna.hide()

    def disastro_soloS2trg(self):
        try:
            self.trgS2_old = devprodic["triggerS2"].command_inout('GetDelay', 2)*1000000000
            procedi = True
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerS2"]) + ' S2Delay.'
            self.logbox.insertItem(0, voce)
            procedi = False
        if procedi:
            self.comandifalliti = 0
            try:
                devprodic["triggerS2"].command_inout('SetDelay', [2,  float(self.trg_S2calc)/1000000000])
                print('S2Delay ' + str(self.trg_S2calc))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerS2"]) + ' while command_inout("SetDelay", [2,' + str(float(self.trg_S2calc)/1000000000) + '])'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
        if self.comandifalliti < 1:
            self.trgS2_applica.hide()
            self.trgS2_storna.show()

    def doppiodisastro_soloS2trg(self):
        devprodic["triggerS2"].command_inout('SetDelay', [2,  float(self.trgS2_old)/1000000000])  
        self.trgS2_applica.show()
        self.trgS2_storna.hide()

    def disastro(self):
        ######## finesta avviso sala controllo
        print('salvo stato')
        procedi = True
        self.comandifalliti = 0
        ###salvo vecchi valori###
        try:
            self.trls8_old = devprodic["trls8"].Position
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["trls8"]) + ' Position. The script will not chage any value. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
            procedi = False
        try:
            self.trgE2_old = devprodic["triggerEVR"].Chan2Delay
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerEVR"]) + ' Chan2Delay. The script will not chage any value. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
            procedi = False
        try:
            self.trgS2_old = devprodic["triggerS2"].command_inout('GetDelay', 2)*1000000000
        except:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            voce = time.ctime()[11:19] + ' Error reading ' + str(devprodic["triggerS2"]) + ' S2Delay. The script will not chage any value. check with atomic panel and launch this program again'
            self.logbox.insertItem(0, voce)
            procedi = False
        if procedi == True:
            print('applico valori')
            try:
                devprodic["triggerEVR"].write_attribute("Chan2Delay", float(self.trg_elite2calc))
                print('Chan2Delay ' + str(self.trg_elite2calc))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while write_attribute("Chan2Delay", ' + str(self.trg_elite2calc) + ')'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
            time.sleep(0.2)
            try:
                tmp = devprodic["triggerEVR"].get_attribute_config_ex("Chan2Delay")
                tmp[0].alarms.min_alarm = str(self.trg_elite2calc - 1)
                tmp[0].alarms.max_alarm = str(self.trg_elite2calc + 1)
                devprodic["triggerEVR"].set_attribute_config(tmp)
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while the script set alarm threshold [' + str(self.trg_elite2calc - 1) + ', ' + str(self.trg_elite2calc +1) + '] for attribute Chan2Delay'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
            print("triggerS1" + ' ' + "SetDelay 2" + ' ' +  str(self.trg_S1calc))
            try:
                devprodic["triggerS1"].command_inout('SetDelay', [2,  float(self.trg_S1calc)/1000000000])
                print('S1Delay ' + str(self.trg_S1calc))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerS1"]) + ' while command_inout("SetDelay", [2,' + str(float(self.trg_S1calc)/1000000000) + '])'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
            time.sleep(0.2)
            print("triggerS2" + ' ' + "SetDelay 2" + ' ' +  str(self.trg_S2calc))
            try:
                devprodic["triggerS2"].command_inout('SetDelay', [2,  float(self.trg_S2calc)/1000000000])
                print('S2Delay ' + str(self.trg_S2calc))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerS2"]) + ' while command_inout("SetDelay", [2,' + str(float(self.trg_S2calc)/1000000000) + '])'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
            time.sleep(0.2)
            print("trls8" + ' ' + "Position" + ' ' +  str(self.trls8calc*1000))
            esciciclo = 0
            while devprodic["trls8"].Speed > -99 or esciciclo < 10:
                esciciclo += 1
                time.sleep(2)
                voce = time.ctime()[11:19] + ' waiting trls8... '
                self.logbox.insertItem(0, voce)
            try:
                devprodic["trls8"].write_attribute("Position", float(self.trls8calc*1000))
                print("trls8 " + str(self.trls8calc*1000))
            except:
                voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["trls8"]) + ' while write_attribute("Position", ' + str(self.trls8calc*1000) + ')'
                self.logbox.insertItem(0, voce)
                self.comandifalliti = 1
            print("done")
            time.sleep(2)
            self.applica.hide()
            self.comenondetto.show()
            self.lanciasalvatrigger.setStyleSheet("background-color: rgb(200, 200, 200)")
            if self.comandifalliti == 1:
                self.funzionamento.setText('!! FAULT !!')
                self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
            else:
                self.funzionamento.setText('No errors')
                self.funzionamento.setStyleSheet("background-color: rgb(0, 255, 0)")

    def doppiodisastro(self):
        self.comandifalliti = 0
        try:
            devprodic["triggerEVR"].write_attribute('Chan2Delay', self.trgE2_old)
            print('Chan2Delay ' + str(self.trgE2_old))
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while write_attribute("Chan2Delay", ' + str(self.trgE2_old) + ')'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        time.sleep(0.1)
        try:
            tmp = devprodic["triggerEVR"].get_attribute_config_ex('Chan2Delay')
            tmp[0].alarms.min_alarm = str(self.trgE2_old - 1)
            tmp[0].alarms.max_alarm = str(self.trgE2_old + 1)
            devprodic["triggerEVR"].set_attribute_config(tmp)
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while the script set alarm threshold [' + str(self.trgE2_old - 1) + ', ' + str(self.trgE2_old +1) + '] for attribute Chan2Delay'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        try:
            devprodic["triggerS2"].command_inout('SetDelay', [2,  float(self.trgS2_old)/1000000000])
            print('S2Delay ' + str(self.trgS2_old))
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerS2"]) + ' while command_inout("SetDelay", [2,' + str(float(self.trgS2_old)/1000000000) + '])'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        time.sleep(0.1)
        try:
            devprodic["trls8"].write_attribute("Position", self.trls8_old)
            print("trls8 " + str(self.trls8_old))
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["trls8"]) + ' while write_attribute("Position", ' + str([self.trls8_old]) + ')'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        print("done")
        time.sleep(1)
        self.applica.show()
        self.comenondetto.hide()
        self.lanciasalvatrigger.setStyleSheet("background-color: rgb(200, 200, 200)")
        if self.comandifalliti == 1:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
        else:
            self.funzionamento.setText('No errors')
            self.funzionamento.setStyleSheet("background-color: rgb(0, 255, 0)")

    def ripristino(self):
        self.comandifalliti = 0
        try:
            devprodic["triggerEVR"].write_attribute('Chan2Delay', self.zero_trgE2)
            print('Chan2Delay ' + str(self.zero_trgE2))
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while write_attribute("Chan2Delay", ' + str(self.zero_trgE2) + ')'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        time.sleep(0.1)
        try:
            tmp = devprodic["triggerEVR"].get_attribute_config_ex('Chan2Delay')
            tmp[0].alarms.min_alarm = str(self.zero_trgE2 - 1)
            tmp[0].alarms.max_alarm = str(self.zero_trgE2 + 1)
            devprodic["triggerEVR"].set_attribute_config(tmp)
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerEVR"]) + ' while the script set alarm threshold [' + str(self.zero_trgE2 - 1) + ', ' + str(self.zero_trgE2 +1) + '] for attribute Chan2Delay'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        try:
            devprodic["triggerS2"].command_inout('SetDelay', [2,  float(self.zero_trgS2)/1000000000])
            print('S2Delay ' + str(self.zero_trgS2))
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["triggerS2"]) + ' while command_inout("SetDelay", [2,' + str(float(self.zero_trgS2)/1000000000) + '])'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        time.sleep(0.1)
        try:
            devprodic["trls8"].write_attribute("Position", self.zero_trls8)
            print("trls8 " + str(self.zero_trls8))
        except:
            voce = time.ctime()[11:19] + ' Error with ' + str(devprodic["trls8"]) + ' while write_attribute("Position", ' + str(self.zero_trls8) + ')'
            self.logbox.insertItem(0, voce)
            self.comandifalliti = 1
        print("done")
        time.sleep(1)
        self.applica.show()
        self.comenondetto.hide()
        self.lanciasalvatrigger.setStyleSheet("background-color: rgb(200, 200, 200)")
        if self.comandifalliti == 1:
            self.funzionamento.setText('!! FAULT !!')
            self.funzionamento.setStyleSheet("background-color: rgb(255, 0, 0)")
        else:
            self.funzionamento.setText('No errors')
            self.funzionamento.setStyleSheet("background-color: rgb(0, 255, 0)")


app = QApplication([])
try:
  tmpdim = sys.argv[1]
  tmpdim = tmpdim.split('x')
  dimensione = [float(tmpdim[0]), float(tmpdim[1])]
except:
  screen = QDesktopWidget().screenGeometry()
  dimensione = [screen.width()*0.7, screen.height()*0.7]
font_pannello = QFont("Arial", round(dimensione[0]/160.0), -1, False)
font_grosso = QFont("Arial", round(dimensione[0]/100.0), -1, True)
app.setFont(font_pannello)
main = MainWindow()
main.show()
app.exec_()
